﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDMTabGroupPane
{
    public class ViewModel : ObservableModel
    {
        private ObservableCollection<DataModel> _data;

        public ObservableCollection<DataModel> Data
        {
            get
            {
                return _data;
            }
            set
            {
                _data = value;
                NotifyPropertyChanged();
            }
        }

        public ViewModel()
        {
            this.Data = new ObservableCollection<DataModel>();
            for (int i = 0; i < 5; i++)
            {
                this.Data.Add(new DataModel() { TabName = "Tab " + i.ToString(), Selected = false });
            }
            this.Data[0].Selected = true;
        }
    }

    public class DataModel :ObservableModel
    {
        private string _tabName { get; set; }
        private bool _selected { get; set; }

        public string TabName
        {
            get
            {
                return _tabName;
            }
            set
            {
                _tabName = value;
                NotifyPropertyChanged();
            }
        }

        public bool Selected
        {
            get
            {
                return _selected;
            }
            set
            {
                _selected = value;
                NotifyPropertyChanged();
            }
        }
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
